%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% REFORMAT_ASCII_ART.M
%
% Steven Wasson
% ECE 443 - Hardware Design with VHDL
% Assignments 5 & 6
% December 1, 2007
%
% The MATLAB script concatenates all of the ASCII art data and saves it in a
% Xilinx Coefficients file.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ascii_file = char('Bugs_Bunny.txt','Pepe_Lepew.txt','Tweety_Bird.txt',...
                  'Bugs_Bunny_2.txt','Tasmanian_Devil.txt','Daffy_Duck.txt');

for file_id = 1:6

  ascii_file(file_id,:)
  
  % Open ascii_file(i)
  fid = fopen(ascii_file(file_id,:));

  % Scan in the first line
  temp = fgets(fid);

  % Scan in the rest of the file
  if(temp ~= -1)
    data = [char(7), temp];
  end
  while(temp ~= -1)
    temp = fgets(fid);
    if(temp ~= -1)
      data = [data, temp];
    end
  end
  
  % Close ascii_file(i)
  fclose(fid);
  
  data = uint8(data);

  disp(['Length of ASCII Art Set ', num2str(file_id), ' = ', num2str(length(data))]);
  
  if(file_id == 1)
    total_data = data;
  else
    total_data = [total_data, data];
  end

end

%char(total_data);

disp(['Total Length of ASCII Art Sets = ', num2str(length(total_data))]);

% Save the data in a Xilinx Coefficients file
fid = fopen('ascii_art.coe', 'wt');
fprintf(fid, 'memory_initialization_radix=16;\n');
fprintf(fid, 'memory_initialization_vector=');
fprintf(fid, '\n%02X', total_data);
fprintf(fid, ';');
fclose(fid);

clear